#include <tag.h>
#include <dfa_matrix.h>
#include <alphabet.h>
#include <language.h>
#include <iterator>
#include <iostream.h>
#include <minimize.h>

//code corresponding to the DFA example, without
//the 10 to 8 transition, in order to avoid cyclicity

main()
{
   //spcifie the type of the DFA, with an appropriate tag
   typedef DFA_matrix<Range_alphabet<char,'a','g'>,minimization_tag> DFA_type;
   
   //initialising the DFA, empty
   DFA_type dfa;
   
   //creating and adding the states
   DFA_type::State s[11];
   for(int i=1;i<=10;i++)
      s[i]=dfa.new_state();
      
   //setting the transitions
   dfa.set_trans(s[1],'a',s[2]);
   dfa.set_trans(s[1],'b',s[3]);   
   dfa.set_trans(s[2],'f',s[4]);
   dfa.set_trans(s[2],'b',s[5]);
   dfa.set_trans(s[3],'c',s[6]);
   dfa.set_trans(s[4],'g',s[7]);
   dfa.set_trans(s[4],'e',s[9]);
   dfa.set_trans(s[5],'g',s[8]);
   dfa.set_trans(s[6],'b',s[5]);
   dfa.set_trans(s[6],'d',s[8]);
   dfa.set_trans(s[6],'e',s[10]);
   dfa.set_trans(s[8],'d',s[10]);
   //dfa.set_trans(s[10],'a',s[8]);
   
   //declaring initial and finals states...VERY IMPORTANT...
   dfa.initial(s[1]);
   dfa.final(s[5])=true;
   dfa.final(s[9])=true;
   dfa.final(s[10])=true;
   
   //writing the language on the standart output
   language(dfa,ostream_iterator<DFA_type::Alphabet>(cout));
   cout<<"nombre d'etats:"<<dfa.state_count()<<endl;
   cout<<"ending language test"<<endl;
   acyclic_minimization(dfa);
   cout<<"dfa minimized"<<endl;
   language(dfa,ostream_iterator<DFA_type::Alphabet>(cout));
   cout<<"nombre d'etats:"<<dfa.state_count()<<endl;
   cout<<"ending language (after minimization) test"<<endl;
   
}

/*OUTPUT WRONG WRONG WRONG. . .
[root@yugoth exemples]# ./minimize 

ab
abgd
afe
bcb
bcbgd
bcdd
bce
nombre d'etats:10
ending language test
dfa minimized
ab
abgd
afe
afg
bc
nombre d'etats:7
ending language (after minimization) test

END OF OUTPUT*/