#include <tag.h>
#include <dfa_matrix.h>
#include <alphabet.h>
#include <iostream.h>
#include <minimize.h>
#include <falgo_stream.h>

//code corresponding to the DFA example

main()
{
   //spcifie the type of the DFA
   typedef DFA_matrix<Range_alphabet<char,'a','g'>, minimization_tag > DFA_type;
   
   //initialising the DFA, empty
   DFA_type dfa;
   
   //creating and adding the states
   DFA_type::State s[11];
   for(int i=1;i<=10;i++)
      s[i]=dfa.new_state();
      
   //setting the transitions
   dfa.set_trans(s[1],'a',s[2]);
   dfa.set_trans(s[1],'b',s[3]);   
   dfa.set_trans(s[2],'f',s[4]);
   dfa.set_trans(s[2],'b',s[5]);
   dfa.set_trans(s[3],'c',s[6]);
   dfa.set_trans(s[4],'g',s[7]);
   dfa.set_trans(s[4],'e',s[9]);
   dfa.set_trans(s[5],'g',s[8]);
   dfa.set_trans(s[6],'b',s[5]);
   dfa.set_trans(s[6],'d',s[8]);
   dfa.set_trans(s[6],'e',s[10]);
   dfa.set_trans(s[8],'d',s[10]);
   dfa.set_trans(s[10],'a',s[8]);
   
   //declaring initial and finals states...VERY IMPORTANT...
   dfa.initial(s[1]);
   dfa.final(s[5])=true;
   dfa.final(s[9])=true;
   dfa.final(s[10])=true;
   
   //printing
   dfa_ascii_write(dfa, cout);
}

/********REM*********
/root/ASTL/falgo_stream.h: In function `void dfa_ascii_write<DFA_matrix<Range_alphabet<char,'a','g'>,empty_tag,allocator_implementation_simple>>(const class DFA_matrix<Range_alphabet<char,'a','g'>,empty_tag,allocator_implementation_simple> &, class ostream &)':
/root/ASTL/falgo_stream.h:52: no match for `ostream & << const empty_tag &'
*********************/

/* OUTPUT
10
1
2 0 0 0 a 2 b 3
2 0 0 0 b 5 f 4
1 0 0 0 c 6
2 0 0 0 e 9 g 7
1 1 0 0 g 8
3 0 0 0 b 5 d 8 e 10
0 0 0 0
1 0 0 0 d 10
0 1 0 0
1 1 0 0 a 8
*/