#ifndef ASTL_CLASS_FILTER_CURSORS
#define ASTL_CLASS_FILTER_CURSORS

// Defines:
// 1. template filter_in_cursor  (forward cursor adapter)
// 2. template filter_out_cursor (forward cursor adapter)

// NON TESTE !!!!!!!!!!!!!!!!!

// A filter cursor is a forward cursor adapter which maps
// alphabet before calling any methods involving letters of transitions
// A filter_in_cursor maps the alphabet before calling forward(a) and find(a) 
// A filter_out_cursor maps the alphabet after calling letter()

// filter_in_cursor
//
// Instanciation parameters:
// 1. ForwardCursor:  the type of the cursor to be adapted
// 2. ObjectFunction: a unary function from unsigned int to unsigned int (filter in)
//
// Requirements:
// None
//

template <class ForwardCursor, class ObjectFunction>
class filter_in_cursor : public ForwardCursor
{
protected:
  ObjectFunction f;

public:
  typedef filter_in_cursor self;
  typedef ForwardCursor super;
  typedef typename super::State State;

  filter_in_cursor(const super &x = super(), const ObjectFunction &of = ObjectFunction())
    : super(x), f(of)
  { }

  bool forward(unsigned int a) {
    return super::forward(f(a));
  }

  bool find(unsigned int a) {
    return super::find(f(a));
  }

  self& operator= (const State &x) {
    super::operator=(x);
    return *this;
  }
};


// filter_out_cursor
//
// Instanciation parameters:
// 1. ForwardCursor:  the type of the cursor to be adapted
// 2. ObjectFunction: a unary function from unsigned int to unsigned int (filter out)
//
// Requirements
// None

template <class ForwardCursor, class ObjectFunction>
class filter_out_cursor : public ForwardCursor
{
protected:
  ObjectFunction f;

public:
  typedef filter_out_cursor self;
  typedef ForwardCursor     super;

  filter_out_cursor(const super &x, const ObjectFunction &of = ObjectFunction())
    : super(x), f(of)
  { }

  unsigned int letter() const {
    return f(super::letter());
  }
};

#endif // ASTL_CLASS_FILTER_CURSORS
