#include <iterator>
#include <algorithm>
#include <vector>

template <class OutputIterator, class DepthFirstCursor>
void language(OutputIterator out,            // where to write
	      DepthFirstCursor first,        // start position
	      DepthFirstCursor last = DepthFirstCursor())  // stop condition
{
  vector<char> word;
  for(word.reserve(32); first != last; ) {
    word.push_back(first.letter());
    if (first.aim_final()) {
      copy(word.begin(), word.end(), out);
      *out = '\n';
      ++out;
    }
    while (!first.forward())  word.pop_back();
  }
}

template <class InputIterator, class ForwardCursor>
bool is_in(InputIterator first, InputIterator last, ForwardCursor c)
{
  for(; first != last && c.forward(*first); ++first);
  return first == last && c.src_final();
}
