#include <astl.h>
#include <dfa_map.h>
#include <cursors/cursor.h>
#include <cursors/language.h>
#include <cursors/filter.h>
#include <cursors/set_operation.h>
#include <astl_tree.h>
#include <iterator>
#include <fstream>
#include <iostream>
#include <string>
#include <vector>
#include <functional>
#include <cursors/helpers.h>
#include <cursors/ccopy.h>
#include <minimize.h>
#include <cursors/sigma_star.h>

typedef DFA_map<Type_alphabet<char>, minimization_tag> DFA;
typedef forward_cursor<DFA> ForwardCursor;

// compile with:
// g++ -Wall -O3 -I../.. -fno-exceptions sample.cpp

// Test set operations:
// Usage: a.out dico
// dico contains one word per line (/usr/dict/words)
// display all words in the dictionary ending by the entered word (Sigma*
// concatenated with the word)

int main(int argc, char **argv)
{
  DFA dfa1, dfa2;  
  if (argc > 1) {
    ifstream f1;
    f1.open(argv[1], ios::in);
    if (!f1) exit(2);
    tree_build(dfa1, istream_iterator<string>(f1), istream_iterator<string>());
    f1.close();
  }
  cout << "dfa1::Q = " << dfa1.state_count() << " ::T = " << dfa1.trans_count()
       << endl;
  cout << "minimizing...";
  cout.flush();
  acyclic_minimization(dfa1);
  cout << endl << "dfa1::Q = " << dfa1.state_count() << " ::T = " << dfa1.trans_count()
       << endl;

  while(1) {
    string w;
    cout << "Ok" << endl;
    cin >> w;
    cout << "copy:" << endl;
    ostream_iterator<char> output(cerr);
    /*
    DFA::State i = 
      ccopy(dfa2, dfirstc(intersectionc(debugc(dfa1),  
					concatenationc(
						       sigma_starc(), 
						       stringc(w.c_str())))));
    dfa2.initial(i); 
    cout << "language:" << endl;
    language(output, dfirstc(debugc(dfa2))); 
    */
    language(output, dfirstc(intersectionc(debugc(dfa1),  
					concatenationc(
						       sigma_starc(), 
						       stringc(w.c_str())))));
  }
  
  cout << "exit." << endl;
  return 0;
}
  
  








