#ifndef ASTL_CLASS_SIGMA_STAR_CURSOR
#define ASTL_CLASS_SIGMA_STAR_CURSOR

#include "cursor.h"

template <unsigned int alphabet_size = 256>
class sigma_star_cursor //: public forward_cursor_base
{
protected:
  static int tag;
  unsigned int l;

public:
  typedef sigma_star_cursor self;
  typedef unsigned int      State;
  typedef int               Tag;

  sigma_star_cursor()
    : l(0) 
    { }

  bool operator== (const self &x) const {
    return l == x.l;
  }

  State src() const {
    return 1;
  }

  State aim() const {
    return 1;
  }    

  const Tag& src_tag() const {
    return tag;
  }
  
  const Tag& aim_tag() const {
    return tag;
  }    
  
  bool src_final() const {
    return true;
  }
  
  bool aim_final() const {
    return true;
  }

  bool sink() const {
    return l == alphabet_size;
  }

  void forward() 
  { }
  
  bool forward(unsigned int a) {
    return true;
  }
  
  unsigned int letter() const {
    return l;
  }
  
  bool first_transition() {
    l = 0;
    return true;
  }
  
  bool next_transition() {
    return ++l < alphabet_size;
  }

  bool find(unsigned int a) {
    l = a;
    return true;
  }
};    
template <unsigned int alphabet_size>
int sigma_star_cursor<alphabet_size>::tag = 0;

#endif // ASTL_CLASS_SIGMA_STAR_CURSOR
    


