//
// File        : inserter.hh
// Date        : Thu Oct 29 17:58:32 MET 1998
// Author      : Vincent Le Maout
// Description : Output iterator class inserting in an associative container
//               algorithm associative_inserter returns an insertion_iterator 
//               on the argument 'container'
//

#ifndef CLASS_INSERTION_ITERATOR
#define CLASS_INSERTION_ITERATOR

template <class Container>
class insertion_iterator {
protected:
  Container* container;
public:
  typedef output_iterator_tag iterator_category;
  typedef void                value_type;
  typedef void                difference_type;
  typedef void                pointer;
  typedef void                reference;

  insertion_iterator(Container& x) : container(&x) {}
  insertion_iterator<Container>&
  operator=(const typename Container::value_type& value) { 
    container->insert(value);
    return *this;
  }
  insertion_iterator<Container>& operator*() { return *this; }
  insertion_iterator<Container>& operator++() { return *this; }
  insertion_iterator<Container>& operator++(int) { return *this; }
};

template <class Container>
insertion_iterator<Container> associative_inserter(Container &c)
{
  return (insertion_iterator<Container>(c));
}

#endif // CLASS_INSERTION_ITERATOR







